unit LineExportOpt;
{$I DFS.inc}
interface

uses
  {$IFDEF MSWINDOWS} Windows, Messages,  {$ENDIF}
  SysUtils, Variants, Classes, Graphics, Controls, Forms, Buttons,
  Dialogs, StdCtrls, AlEdit, EditExtr, NewSpin, Mixture;

type
  TLineExportOptions = class(TForm)
    FitFormatCheck: TCheckBox;
    ThresholdSpin: TFixedSpin;
    Label1: TLabel;
    OKButton: TButton;
    CancelButton: TButton;
    procedure ThresholdSpinIncrement(Sender: TObject; var NewValue: Double;
      LastValue: Double; n: Integer);
  end;

var
  LineExportOptions: TLineExportOptions;

implementation

{$IFNDEF FPC}
{$R *.dfm}
{$ELSE}
{$R *.lfm}
{$ENDIF}

procedure TLineExportOptions.ThresholdSpinIncrement(Sender: TObject;
  var NewValue: Double; LastValue: Double; n: Integer);
begin
  if LastValue <= 0 then
    LastValue := 1e-6;
  if n < 0 then
    NewValue := LastValue / 10
  else
    NewValue := LastValue * 10;
end;

end.
