unit Lapack;
{$I DFS.inc}
interface

uses MathSup, f2c;

function dsytrd_(var uplo: Char; var n: Integer; var a: Double; var lda: Integer; var d__: Double; var e: Double; var tau: Double; var work: Double; var lwork: Integer; var info: Integer; uplo_len: Integer): Integer; cdecl; external;
function dlaebz_(var ijob: Integer; var nitmax: Integer; var n: Integer; var mmax: Integer; var minp: Integer; var nbmin: Integer; var abstol: Double; var reltol: Double; var pivmin: Double; var d__: Double; var e: Double; var e2: Double; var nval: Integer; var ab: Double; var c__: Double; var mout: Integer; var nab: Integer; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external;
function dlagtf_(var n: Integer; var a: Double; var lambda: Double; var b: Double; var c__: Double; var tol: Double; var d__: Double; var in__: Integer; var info: Integer): Integer; cdecl; external;
function dlagts_(var job: Integer; var n: Integer; var a: Double; var b: Double; var c__: Double; var d__: Double; var in__: Integer; var y: Double; var tol: Double; var info: Integer): Integer; cdecl; external;
function dlamch_(var cmach: Char; cmach_len: Integer): Double; cdecl; external;
function dlamc1_(var beta: Integer; var t: Integer; var rnd: LogBool; var ieee1: LogBool): Integer; cdecl; external;
function dlamc2_(var beta: Integer; var t: Integer; var rnd: LogBool; var eps: Double; var emin: Integer; var rmin: Double; var emax: Integer; var rmax: Double): Integer; cdecl; external;
function dlamc4_(var emin: Integer; var start: Double; var base: Integer): Integer; cdecl; external;
function dlamc5_(var beta: Integer; var p: Integer; var emin: Integer; var ieee: LogBool; var emax: Integer; var rmax: Double): Integer; cdecl; external;
function dlanst_(var norm: Char; var n: Integer; var d__: Double; var e: Double; norm_len: Integer): Double; cdecl; external;
function dlansy_(var norm: Char; var uplo: Char; var n: Integer; var a: Double; var lda: Integer; var work: Double; norm_len: Integer; uplo_len: Integer): Double; cdecl; external;
function dlapy2_(var x: Double; var y: Double): Double; cdecl; external;
function dlar1v_(var n: Integer; var b1: Integer; var bn: Integer; var sigma: Double; var d__: Double; var l: Double; var ld: Double; var lld: Double; var gersch: Double; var z__: Double; var ztz: Double; var mingma: Double; var r__: Integer; var isuppz: Integer; var work: Double): Integer; cdecl; external;
function dlarf_(var side: Char; var m: Integer; var n: Integer; var v: Double; var incv: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; side_len: Integer): Integer; cdecl; external;
function dlarfb_(var side: Char; var trans: Char; var direct: Char; var storev: Char; var m: Integer; var n: Integer; var k: Integer; var v: Double; var ldv: Integer; var t: Double; var ldt: Integer; var c__: Double; var ldc: Integer; var work: Double; var ldwork: Integer; side_len: Integer; trans_len: Integer; direct_len: Integer; storev_len: Integer): Integer; cdecl; external;
function dlarfg_(var n: Integer; var alpha: Double; var x: Double; var incx: Integer; var tau: Double): Integer; cdecl; external;
function dlarft_(var direct: Char; var storev: Char; var n: Integer; var k: Integer; var v: Double; var ldv: Integer; var tau: Double; var t: Double; var ldt: Integer; direct_len: Integer; storev_len: Integer): Integer; cdecl; external;
function dlarnv_(var idist: Integer; var iseed: Integer; var n: Integer; var x: Double): Integer; cdecl; external;
function dlarrb_(var n: Integer; var d__: Double; var l: Double; var ld: Double; var lld: Double; var ifirst: Integer; var ilast: Integer; var sigma: Double; var reltol: Double; var w: Double; var wgap: Double; var werr: Double; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external;
function dlarre_(var n: Integer; var d__: Double; var e: Double; var tol: Double; var nsplit: Integer; var isplit: Integer; var m: Integer; var w: Double; var woff: Double; var gersch: Double; var work: Double; var info: Integer): Integer; cdecl; external;
function dlarrf_(var n: Integer; var d__: Double; var l: Double; var ld: Double; var lld: Double; var ifirst: Integer; var ilast: Integer; var w: Double; var dplus: Double; var lplus: Double; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external;
function dlarrv_(var n: Integer; var d__: Double; var l: Double; var isplit: Integer; var m: Integer; var w: Double; var iblock: Integer; var gersch: Double; var tol: Double; var z__: Double; var ldz: Integer; var isuppz: Integer; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external;
function dlaruv_(var iseed: Integer; var n: Integer; var x: Double): Integer; cdecl; external;
function dlascl_(var type__: Char; var kl: Integer; var ku: Integer; var cfrom: Double; var cto: Double; var m: Integer; var n: Integer; var a: Double; var lda: Integer; var info: Integer; type_len: Integer): Integer; cdecl; external;
function dlaset_(var uplo: Char; var m: Integer; var n: Integer; var alpha: Double; var beta: Double; var a: Double; var lda: Integer; uplo_len: Integer): Integer; cdecl; external;
function dlasq2_(var n: Integer; var z__: Double; var info: Integer): Integer; cdecl; external;
function dlasq5_(var i0: Integer; var n0: Integer; var z__: Double; var pp: Integer; var tau: Double; var dmin__: Double; var dmin1: Double; var dmin2: Double; var dn: Double; var dnm1: Double; var dnm2: Double; var ieee: LogBool): Integer; cdecl; external;
function dlasq6_(var i0: Integer; var n0: Integer; var z__: Double; var pp: Integer; var dmin__: Double; var dmin1: Double; var dmin2: Double; var dn: Double; var dnm1: Double; var dnm2: Double): Integer; cdecl; external;
function dlasrt_(var id: Char; var n: Integer; var d__: Double; var info: Integer; id_len: Integer): Integer; cdecl; external;
function dlassq_(var n: Integer; var x: Double; var incx: Integer; var scale: Double; var sumsq: Double): Integer; cdecl; external;
function dlatrd_(var uplo: Char; var n: Integer; var nb: Integer; var a: Double; var lda: Integer; var e: Double; var tau: Double; var w: Double; var ldw: Integer; uplo_len: Integer): Integer; cdecl; external;
function dorm2l_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dorm2r_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dormtr_(var side: Char; var uplo: Char; var trans: Char; var m: Integer; var n: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dstebz_(var range: Char; var order: Char; var n: Integer; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var abstol: Double; var d__: Double; var e: Double; var m: Integer; var nsplit: Integer; var w: Double; var iblock: Integer; var isplit: Integer; var work: Double; var iwork: Integer; var info: Integer; range_len: Integer; order_len: Integer): Integer; cdecl; external;
function dstein_(var n: Integer; var d__: Double; var e: Double; var m: Integer; var w: Double; var iblock: Integer; var isplit: Integer; var z__: Double; var ldz: Integer; var work: Double; var iwork: Integer; var ifail: Integer; var info: Integer): Integer; cdecl; external;
function dsterf_(var n: Integer; var d__: Double; var e: Double; var info: Integer): Integer; cdecl; external;
function dsyevr_(var jobz: Char; var range: Char; var uplo: Char; var n: Integer; var a: Double; var lda: Integer; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var abstol: Double; var m: Integer; var w: Double; var z__: Double; var ldz: Integer; var isuppz: Integer; var work: Double; var lwork: Integer; var iwork: Integer; var liwork: Integer; var info: Integer; jobz_len: Integer; range_len: Integer; uplo_len: Integer): Integer; cdecl; external;
function dsytd2_(var uplo: Char; var n: Integer; var a: Double; var lda: Integer; var d__: Double; var e: Double; var tau: Double; var info: Integer; uplo_len: Integer): Integer; cdecl; external;
function dlae2_(var a: Double; var b: Double; var c__: Double; var rt1: Double; var rt2: Double): Integer; cdecl; external;
function ilaenv_(var ispec: Integer; var name__: Char; var opts: Char; var n1: Integer; var n2: Integer; var n3: Integer; var n4: Integer; name_len: Integer; opts_len: Integer): Integer; cdecl; external;

function dgetrf_(var m: Integer; var n: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var info: Integer): Integer; cdecl; external;
function dgetf2_(var m: Integer; var n: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var info: Integer): Integer; cdecl; external;
function dlaswp_(var n: Integer; var a: Double; var lda: Integer; var k1: Integer; var k2: Integer; var ipiv: Integer; var incx: Integer): Integer; cdecl; external;
function dtrtri_(var uplo: Char; var diag: Char; var n: Integer; var a: Double; var lda: Integer; var info: Integer; uplo_len: Integer; diag_len: Integer): Integer; cdecl; external;
function dtrti2_(var uplo: Char; var diag: Char; var n: Integer; var a: Double; var lda: Integer; var info: Integer; uplo_len: Integer; diag_len: Integer): Integer; cdecl; external;
function dgetri_(var n: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var work: Double; var lwork: Integer; var info: Integer): Integer; cdecl; external;
function dgetrs_(var trans: Char; var n: Integer; var nrhs: Integer; var a: Double; var lda: Integer; var ipiv: Integer; var b: Double; var ldb: Integer; var info: Integer; trans_len: Integer): Integer; cdecl; external;


function zheevr_(var jobz: Char; var range: Char; var uplo: Char; var n: Integer; var a: Complex; var lda: Integer; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var abstol: Double; var m: Integer; var w: Double; var z__: Complex; var ldz: Integer; var isuppz: Integer; var work: Complex; var lwork: Integer; var rwork: Double; var lrwork: Integer; var iwork: Integer; var liwork: Integer; var info: Integer; jobz_len: Integer; range_len: Integer; uplo_len: Integer): Integer; cdecl; external;
function zunmtr_(var side: Char; var uplo: Char; var trans: Char; var m: Integer; var n: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; uplo_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dladiv_(var a: Double; var b: Double; var c__: Double; var d__: Double; var p: Double; var q: Double): Integer; cdecl; external;
function dlapy3_(var x: Double; var y: Double; var z__: Double): Double; cdecl; external;
function ilazlc_(var m: Integer; var n: Integer; var a: Complex; var lda: Integer): Integer; cdecl; external;
function zhetd2_(var uplo: Char; var n: Integer; var a: Complex; var lda: Integer; var d__: Double; var e: Double; var tau: Complex; var info: Integer; uplo_len: Integer): Integer; cdecl; external;
function zhetrd_(var uplo: Char; var n: Integer; var a: Complex; var lda: Integer; var d__: Double; var e: Double; var tau: Complex; var work: Complex; var lwork: Integer; var info: Integer; uplo_len: Integer): Integer; cdecl; external;
function zlacgv_(var n: Integer; var x: Complex; var incx: Integer): Integer; cdecl; external;
function zladiv_(var ret_val: Complex; var x: Complex; var y: Complex): Integer; cdecl; external;
function zlansy_(var norm: Char; var uplo: Char; var n: Integer; var a: Complex; var lda: Integer; var work: Double; norm_len: Integer; uplo_len: Integer): Double; cdecl; external;
function zlar1v_(var n: Integer; var b1: Integer; var bn: Integer; var lambda: Double; var d__: Double; var l: Double; var ld: Double; var lld: Double; var pivmin: Double; var gaptol: Double; var z__: Complex; var wantnc: LogBool; var negcnt: Integer; var ztz: Double; var mingma: Double; var r__: Integer; var isuppz: Integer; var nrminv: Double; var resid: Double; var rqcorr: Double; var work: Double): Integer; cdecl; external;
function zlarf_(var side: Char; var m: Integer; var n: Integer; var v: Complex; var incv: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; side_len: Integer): Integer; cdecl; external;
function zlarfb_(var side: Char; var trans: Char; var direct: Char; var storev: Char; var m: Integer; var n: Integer; var k: Integer; var v: Complex; var ldv: Integer; var t: Complex; var ldt: Integer; var c__: Complex; var ldc: Integer; var work: Complex; var ldwork: Integer; side_len: Integer; trans_len: Integer; direct_len: Integer; storev_len: Integer): Integer; cdecl; external;
function zlarfg_(var n: Integer; var alpha: Complex; var x: Complex; var incx: Integer; var tau: Complex): Integer; cdecl; external;
function zlarrv_(var n: Integer; var vl: Double; var vu: Double; var d__: Double; var l: Double; var pivmin: Double; var isplit: Integer; var m: Integer; var dol: Integer; var dou: Integer; var minrgp: Double; var rtol1: Double; var rtol2: Double; var w: Double; var werr: Double; var wgap: Double; var iblock: Integer; var indexw: Integer; var gers: Double; var z__: Complex; var ldz: Integer; var isuppz: Integer; var work: Double; var iwork: Integer; var info: Integer): Integer; cdecl; external;
function zlaset_(var uplo: Char; var m: Integer; var n: Integer; var alpha: Complex; var beta: Complex; var a: Complex; var lda: Integer; uplo_len: Integer): Integer; cdecl; external;
function zlassq_(var n: Integer; var x: Complex; var incx: Integer; var scale: Double; var sumsq: Double): Integer; cdecl; external;
function zlatrd_(var uplo: Char; var n: Integer; var nb: Integer; var a: Complex; var lda: Integer; var e: Double; var tau: Complex; var w: Complex; var ldw: Integer; uplo_len: Integer): Integer; cdecl; external;
function zstein_(var n: Integer; var d__: Double; var e: Double; var m: Integer; var w: Double; var iblock: Integer; var isplit: Integer; var z__: Complex; var ldz: Integer; var work: Double; var iwork: Integer; var ifail: Integer; var info: Integer): Integer; cdecl; external;
function zstemr_(var jobz: Char; var range: Char; var n: Integer; var d__: Double; var e: Double; var vl: Double; var vu: Double; var il: Integer; var iu: Integer; var m: Integer; var w: Double; var z__: Complex; var ldz: Integer; var nzc: Integer; var isuppz: Integer; var tryrac: LogBool; var work: Double; var lwork: Integer; var iwork: Integer; var liwork: Integer; var info: Integer; jobz_len: Integer; range_len: Integer): Integer; cdecl; external;
function zunm2l_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function zunm2r_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; external;

function dgesdd_(var JOBZ: Char; var M: Integer; var N: Integer; var A: Double {1..LDA,1..*}; var LDA: Integer; var S: Double {1..*};
                 var U: Double {1..LDU,1..*}; var LDU: Integer; var VT: Double {1..LDVT,1..*}; var LDVT: Integer; var WORK: Double {1..*};
                 var LWORK: Integer; var IWORK: Integer; var INFO: Integer; jobz_len: Integer): Integer; cdecl; external;

{ Not thread safe on older compilers }
function dormql_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; {$IFNDEF PARTPASCAL} external; {$ENDIF}
function dormqr_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; {$IFNDEF PARTPASCAL} external; {$ENDIF}
function zunmql_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; {$IFNDEF PARTPASCAL} external; {$ENDIF}
function zunmqr_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; {$IFNDEF PARTPASCAL} external; {$ENDIF}

function dtrtrs_(var uplo, trans, diag: Char; var n, nrhs: Integer; var a: Double{1..LDA,1..*}; var lda: Integer; var b: Double{1..LDB,1..*}; var ldb, info: Integer; uplo_len, trans_len, diag_len: Integer): Integer; cdecl; external;
function dgels_(var TRANS: Char; var M: Integer; var N: Integer; var NRHS: Integer;
                 var A: Double {1..LDA,1..*}; var LDA: Integer; var B: Double {1..LDB,1..*}; var LDB: Integer;
                 var WORK: Double {1..*}; var LWORK: Integer; var INFO: Integer; trans_len: Integer): Integer; cdecl; external;

function dgelsd_(var M: Integer; var N: Integer; var NRHS: Integer;
                 var A: Double {1..LDA,1..*}; var LDA: Integer; var B: Double {1..LDB,1..*}; var LDB: Integer;
                 var S: Double {1..*}; var RCOND: Double; var Rank: Integer;
                 var WORK: Double {1..*}; var LWORK: Integer; var IWORK: Integer; {1..*} var INFO: Integer): Integer; cdecl; external;


{$IFDEF PARTPASCAL}
function dormqlex_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer;  var t: Double; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dormlqex_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer;  var t: Double; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function dormqrex_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer;  var t: Double; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function zunmqlex_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; var t: Complex; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
function zunmqrex_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; var t: Complex; side_len: Integer; trans_len: Integer): Integer; cdecl; external;
{$ENDIF}

function ieeeck_(var ispec: Integer; var zero: Single; var one: Single): Integer; cdecl;
  {$IFNDEF VCL_} external; {$ENDIF}

implementation

uses Blas, SysUtils, Math;

{$IFDEF FPC}
{$IFNDEF EXTLAPACK}
{$LINKLIB plapack,STATIC}
{$ENDIF}
{$ELSE}
{$LINK lapack.pobj}
{$ENDIF}

{$IFDEF VCL_}
function ieeeck_(var ispec: Integer; var zero, one: Single): integer; cdecl;
begin
  { Override ieeeck routine from lapack, as must be compiled with optimization off }
  Result := ieeeinfandnan_;
end;
{$ENDIF}

{$IFDEF PARTPASCAL}

{$IFDEF FPC}
{$MACRO ON}
{$IFDEF DARWIN}
{$DEFINE alias_:=alias: #95}
{$ELSE}
{$IFDEF MSWINDOWS}
{$DEFINE alias_:=alias: #95}
{$ELSE}
{$DEFINE alias_:=alias:}
{$ENDIF}
{$ENDIF}
{$ENDIF}

const
  NBMAX:Integer = 64;
  LDT:Integer = 65;

function zunmql_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl;
var
  T: array [1..65*64] of Complex; { Was [LDT, NBMAX] }
begin
  Result := zunmqlex_(side,trans,m,n,k,a,lda,tau,c__,ldc,work,lwork,info,T[1],side_len,trans_len)
end;

function zunmqr_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Complex; var lda: Integer; var tau: Complex; var c__: Complex; var ldc: Integer; var work: Complex; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; {$IFNDEF PARTPASCAL} external; {$ENDIF}
var
  T: array [1..65*64] of Complex; { Was [LDT, NBMAX] }
begin
  Result := zunmqrex_(side,trans,m,n,k,a,lda,tau,c__,ldc,work,lwork,info,T[1],side_len,trans_len)
end;

function dormql_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl;
var
  T: array [1..65*64] of Double; { Was [LDT, NBMAX] }
begin
  Result := dormqlex_(side,trans,m,n,k,a,lda,tau,c__,ldc,work,lwork,info,T[1],side_len,trans_len)
end;

function dormqr_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl; {$IFNDEF PARTPASCAL} external; {$ENDIF}
var
  T: array [1..65*64] of Double; { Was [LDT, NBMAX] }
begin
  Result := dormqrex_(side,trans,m,n,k,a,lda,tau,c__,ldc,work,lwork,info,T[1],side_len,trans_len)
end;

function dormlq_(var side: Char; var trans: Char; var m: Integer; var n: Integer; var k: Integer; var a: Double; var lda: Integer; var tau: Double; var c__: Double; var ldc: Integer; var work: Double; var lwork: Integer; var info: Integer; side_len: Integer; trans_len: Integer): Integer; cdecl;
var
  T: array [1..65*64] of Double; { Was [LDT, NBMAX] }
begin
  Result := dormlqex_(side,trans,m,n,k,a,lda,tau,c__,ldc,work,lwork,info,T[1],side_len,trans_len)
end;

{$ENDIF}

{ Force a single threaded call to DLAMCH, as (only) the first call is not thread safe }
var
  d: Double;
  c: Char;
initialization
  { LAPACK prefers exZeroDivide and exInvalidOp to be masked }
  {$IFNDEF CPUPOWERPC}
    { Comment next line out under Delphi to turn on exceptions }
    SetExceptionMask(GetExceptionMask+[exZeroDivide,{exOverflow,}exInvalidOp]);
  {$ELSE}
    asm
      mtfsfi 6,0 // all floating point exceptions disabled - seems to be required for correct LAPACK operation
    end;
  {$ENDIF}
  {$IFDEF CPUX86_64} {$IFDEF VER2_0_4}
    { FPC bug workaround }
    SetSSECSR((((GetSSECSR shr 7) and $ffffffc0) or dword(SetExceptionMask([exDenormalized,exUnderflow,exPrecision,exInvalidOp,exZeroDivide]))) shl 7);
  {$ENDIF} {$ENDIF}
  c := 'E';
  d := dlamch_(c, 1);
end.


