unit ShowMat;
{$I DFS.inc}{ Copyright (C) 2010 C M Western; see UCompat.pas for license}
interface

uses MatrixVec;

type TShowMatrixProc = procedure (AMatrix: TMatrix; ACaption: string; cv: TColumnVector);
var ShowMatrixProc: TShowMatrixProc = nil;

procedure ShowMatrix(AMatrix: TMatrix; ACaption: string; cv: TColumnVector);

implementation

uses Worker, MathSup;

procedure ShowMatrix(AMatrix: TMatrix; ACaption: string; cv: TColumnVector);
var
  i, j: Integer;
begin
  if Assigned(ShowMatrixProc) then
    ShowMatrixProc(AMatrix, ACaption, cv)
  else if not Assigned(cv) then
    AMatrix.Write(Log,ACaption,20)
  else begin
    WriteLn(Log, ACaption);
    Write(Log, ' ':20);
    for i := 1 to AMatrix.ColCount do
      Write(Log, i:20);
    WriteLn(Log);
    for i := 1 to AMatrix.RowCount do begin
      Write(Log, cv[i]:20);
      for j := 1 to AMatrix.ColCount do
        Write(Log, AMatrix[i,j]:20);
      WriteLn(Log);
    end;
    WriteLn(Log);
  end;
end;

end.

