#MSYS = G:\Apps\1.0
#MG = $(MSYS)\mingw\bin\\

all: $(POBJ)

.obj.pobj:
	copy $< $@
	copy $@ ..

clean:
	-del *.OBJ *.asm
	-del $(OBJ:.obj=.f)

.f.asm:
	$(MG)gfortran -O3 -funroll-all-loops -funsafe-math-optimizations -mfancy-math-387 -masm=intel -frecursive -S -o $@ $<
# Should be compiled with -frecursive, when available

.asm.obj:
	copy $< org.asm
	sed -e"s/_\([a-zA-Z0-9]*\)_/\1_/" $< >b1.asm
	sed -e "/.def/d" b1.asm >wibble.asm
	sed -e "/.def/!d" -e"s/.def/GLOBAL/" -e"s/;/:NEAR;/" -e"s/\.scl.*endef//" b1.asm >wglobals.asm
	sed -f ../../utils/tasmfix wibble.asm >$<
	tasm32 /w-ALN /kh17000 $<,$@

$(OBJ:.obj=.f): $(SOURCES)
	cat $** >$@

